#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <sstream>
#include <map>
#include <set>
#include <queue>
#include <vector>

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;

#define PB push_back
#define MP make_pair

#define FOR(prom, a, b) for(int prom = (a); prom < (b); prom++)
#define FORD(prom, a, b) for(int prom = (a); prom > (b); prom--)
#define FORDE(prom, a, b) for(int prom = (a); prom >= (b); prom--)
#define R1(a) do{scanf("%d", &(a));}while(0)
#define R2(a, b) do{scanf("%d%d", &(a), &(b));}while(0)
#define R3(a, b, c) do{scanf("%d%d%d", &(a), &(b), &(c));}while(0)
#define SV(vec) do{int s_v_;scanf("%d", &(s_v_));vec.PB(s_v_);}while(0)
#define MM(co, cim) memset((co), (cim), sizeof((co)))
#define DEB(x) cerr << ">>> " << #x << " : " << x << endl;
#define INF 1000000007

#define SHEEP_DEATH 5
#define WOLF_DEATH 10

int t, n, m, grow[24][24], eat[24][24], oldeat[24][24], death[24][24];
char b[24][24], oldb[24][24], c;

void move (int x1, int y1, int x2, int y2)
{
  if (b[x2][y2] != '.') //nekdo uz tam je
  {
    b[x2][y2] = 'W';
    eat[x2][y2] = 0;
    death[x2][y2] = 1;
  }
  else //volno
  {
    b[x2][y2] = oldb[x1][y1];
    eat[x2][y2] = oldeat[x1][y1];
  }
}

int main ()
{
  R3(t, n, m);
  MM(grow, 0);
  MM(eat, 0);
  MM(death, 0);
  FOR(i, 0, n) FOR(j, 0, m) 
  {
    scanf(" %c", &(b[i][j]));
    if (b[i][j] == 'W' || b[i][j] == 'S') eat[i][j] = 1;
  }
  FOR(qq, 0, t)
  {
    //1. pohyb + 2. zrani ovci vlky
    //---------
    FOR(i, 0, n) FOR(j, 0, m) 
    {
      oldb[i][j] = b[i][j];
      b[i][j] = '.';
      oldeat[i][j] = eat[i][j];
      eat[i][j] = 0;
    }
    FOR(i, 0, n) FOR(j, 0, m)
    {
      if (oldb[i][j] == 'W') move(i, j, i, (j + 1) % m); 
      else if (oldb[i][j] == 'S') move(i, j, (i + 1) % n, j);
    }
    //3. ovce ji travu
    //---------
    FOR(i, 0, n) FOR(j, 0, m)
    {
      if (b[i][j] == 'S' && grow[i][j] == 3 && !death[i][j])
      {
        eat[i][j] = 0;
        grow[i][j] = -1;
      }
    }
    //4. umreni na jidlo
    //---------
    FOR(i, 0, n) FOR(j, 0, m)
    {
      if ((b[i][j] == 'W' && eat[i][j] >= WOLF_DEATH) ||
          (b[i][j] == 'S' && eat[i][j] >= SHEEP_DEATH))
      {
        b[i][j] = '.';
        eat[i][j] = 0;
        death[i][j] = 1;
      }
    }
    //5. roste trava + vsichni jsou hladovejsi
    //---------
    FOR(i, 0, n) FOR(j, 0, m) 
    {
      if (b[i][j] != '.') ++eat[i][j];
      grow[i][j] = min(grow[i][j] + 1, 3);
    }
  }
  FOR(i, 0, n) 
  {
    FOR(j, 0, m)
    {
      if (b[i][j] == 'W' || b[i][j] == 'S') printf("%c", b[i][j]);
      else
      {
        if (death[i][j]) printf("*");
        else printf("%c", grow[i][j] == 3 ? '#' : '.');
      }
    }
    printf("\n");
  }
  return 0;
}
